package com.webcmsnow.api.acceptance.test.step.definitions;

import com.webcmsnow.api.acceptance.test.common.World;

import cucumber.api.Scenario;

import org.springframework.beans.factory.annotation.Autowired;

/**
 * Common methods for all step definitions
 */
public abstract class AbstractStepDefinition {

    protected Scenario scenario;

    @Autowired
    protected World world;

    /**
     * Get a reference to the current cucumber scenario
     * Supports writing text and xml to report within test steps
     * @param scenario
     */
    public void before(Scenario scenario) {
        this.scenario = scenario;
    }

    protected void embedTextInReport(String text) {
        scenario.write(text);
    }

    protected void embedXmlInReport(String xml) {
        xml = "<textarea readonly>" + xml + "</textarea>";
        scenario.write(xml);
    }
}
